Leetcode 523: Continuous Subarray Sum 前缀和数组典型题

  1. Continuous Subarray Sum
    Medium
    Given an integer array nums and an integer k, return true if nums has a good subarray or false otherwise.

A good subarray is a subarray where:

its length is at least two, and
the sum of the elements of the subarray is a multiple of k.
Note that:

A subarray is a contiguous part of the array.
An integer x is a multiple of k if there exists an integer n such that x = n * k. 0 is always a multiple of k.

Example 1:

Input: nums = [23,2,4,6,7], k = 6
Output: true
Explanation: [2, 4] is a continuous subarray of size 2 whose elements sum up to 6.
Example 2:

Input: nums = [23,2,6,4,7], k = 6
Output: true
Explanation: [23, 2, 6, 4, 7] is an continuous subarray of size 5 whose elements sum up to 42.
42 is a multiple of 6 because 42 = 7 * 6 and 7 is an integer.
Example 3:

Input: nums = [23,2,6,4,7], k = 13
Output: false

Constraints:

1 <= nums.length <= 105
0 <= nums[i] <= 109
0 <= sum(nums[i]) <= 231 - 1
1 <= k <= 231 - 1

解法1:
前缀和数组+hashmap。
注意:y - x = nk,说明y % k == x % k!

class Solution {
public:
    bool checkSubarraySum(vector<int>& nums, int k) {
        int n = nums.size();
        vector<int> presums(n + 1, 0);
        unordered_map<int, int> mp;
        mp[0] = 0;
        int res = 0;
        for (int i = 1; i <= n; i++) {
            presums[i] = presums[i - 1] + nums[i - 1];
            int remainder = presums[i] % k;
            if (mp.find(remainder) == mp.end()) {
                mp[remainder] = i;
            } else {
                int gap = i - mp[remainder];
                if (gap >= 2) {
                    res = max(res, gap);
                }
            }
        }
        return res;
    }
};

你可能感兴趣的:(leetcode,算法,数据结构)